/**
 * norris-tester
 * Copyright (c) 2011 Ruben L Z Tan
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS 
 * IN THE SOFTWARE.
 */
'use strict';

var vows   = require('vows');
var assert = require('assert');

module.exports.make = function() {

	///////////////////////////////////////////////////////////////////////////
	// NORRIS-tester test suite
	///////////////////////////////////////////////////////////////////////////
	var suite = vows.describe('NORRIS-tester test suite');

	//-------------------------------------------------------------------------
	// General case batch
	suite.addBatch({
		'GIVEN to test dir recursive walking, WHEN we make it walk the "mock" dir' : {
			topic : function topic() {
				var tester = require('../lib/tester');
				tester.run(this.callback);
			},

			'THEN a total of 4 tests should be executed' : function test(err, results) {
				assert.equal(results.length, 4);
			},

			'THEN there should be 2 passes' : function test(err, results) {
				assert.equal(results.passed, 2);
			},

			'THEN there should be 1 failed' : function test(err, results) {
				assert.equal(results.failed, 1);
			},

			'THEN there should be 1 skipped' : function test(err, results) {
				assert.equal(results.skipped, 1);
			}
		}
	});

	//-------------------------------------------------------------------------
	// Edge case batch
	suite.addBatch({});

	return suite;

}